Highlights:
   - **Bug fixes**
      - Add argument 'module' to 'warn_explicit' to show the deprecated warning (#6467) (by **Lin Jiang**)
      - Fix cache_loop_invariant_global_vars pass (#6462) (by **Lin Jiang**)
      - Fix memory leak in SPIRV module (#6449) (by **yekuang**)
   - **CUDA backend**
      - Add maximum stack limit to CompileConfig (#6455) (by **Lin Jiang**)
   - **Documentation**
      - Update global_settings.md (#6370) (by **Zhao Liang**)
      - Update global data access rule checker in doc (#6347) (by **Mingrui Zhang**)
   - **Error messages**
      - Shorten traceback for _BoundedDifferentiableMethod (#6475) (by **Lin Jiang**)
      - Return NotImplemented for operations between field and Expr/Matrix/Struct (#6474) (by **Lin Jiang**)
      - Return TaichiTypeError in ASTTransformer when a binary op is not supported (#6477) (by **Lin Jiang**)
      - Deprecate ndrange with number of the loop variables != the dimension of the ndrange (#6422) (by **Lin Jiang**)
      - Add error message when the number of the loop variables does not match the dimension of the ndrange (#6360) (by **Lin Jiang**)
   - **Language and syntax**
      - MatrixType refactor: Support inverse() (#6542) (by **Yi Xu**)
      - MatrixType refactor: Support matrix factories (#6560) (by **Yi Xu**)
      - MatrixType refactor: Support dot/cross/outer_product (#6545) (by **Yi Xu**)
      - Add deactivate attribute to dynamic snodes (#6512) (by **Zhao Liang**)
      - Matrix lib: Stop changing dimension in transpose() (#6528) (by **Yi Xu**)
      - Add element access for sparse matrix on CUDA (#6250) (by **Jiafeng Liu**)
      - MatrixType refactor part 2: add more ops (#6425) (by **Mike He**)
      - MatrixType refactor: Support matrix slice (#6430) (by **Yi Xu**)
      - Allow augmented assign on matric slice (#6382) (by **Yi Xu**)
      - Allow filling a field with Expr (#6391) (by **Yi Xu**)
      - Replace matrix warning param by current logging level (#6377) (by **Zhao Liang**)
      - Matrix/Vector refactor: Matrix operations part 1 (#6319) (by **Mike He**)
   - **Miscellaneous**
      - Improve gif output compression rate (#6289) (by **Zhao Liang**)

Full changelog:
   - [ci] CUDA tests speed up (#6516) (by **Proton**)
   - [bug] MatrixType bug fix: Fix indexing support for custom vector types (#6568) (by **Zhanlue Yang**)
   - [ci] Relax timeout for gpu jobs and memory limit (#6601) (by **Ailing**)
   - [lang] Fix sparse matrix builder segment fault (#6592) (by **pengyu**)
   - [lang] MatrixType bug fix: Add attributes n & m (#6585) (by **Yi Xu**)
   - [lang] Unify Cuda and CPU linear solve API (#6578) (by **pengyu**)
   - [build] Remove macOS 10.14 (#6596) (by **Zhanlue Yang**)
   - [aot] Make MoltenVK builds more flexible (#6582) (by **PENGUINLIONG**)
   - [ci] Terminate workers even earlier when test fails (#6587) (by **Proton**)
   - [cuda] Parallelize random state initialization in ti.init() (#6586) (by **Proton**)
   - [build] Remove macOS 10.14 from release tests (#6584) (by **Zhanlue Yang**)
   - Revert "[lang] Build sparse matrix using ndarray" (#6583) (by **Yi Xu**)
   - [lang] Build sparse matrix using ndarray (#6563) (by **pengyu**)
   - [lang] Unify Cuda and CPU Spmv API (#6575) (by **pengyu**)
   - [lang] Add fused foreach check (#6525) (by **Mike He**)
   - [doc] Update sparse.md (#6580) (by **Zhao Liang**)
   - [Lang] MatrixType refactor: Support inverse() (#6542) (by **Yi Xu**)
   - [bug] Sync after executing kernels which have print inside (#6577) (by **Lin Jiang**)
   - [aot] Make arch an optional argument in ti.aot.Module (#6574) (by **Ailing**)
   - [aot] [ci] Change taichi-aot-demo branch back to master (#6567) (by **Ailing**)
   - [bug] Fix real_matrix support for Dynamic SNode (#6553) (by **Zhanlue Yang**)
   - [build] Downgrade molten-vk version to v1.1.10 (#6564) (by **Zhanlue Yang**)
   - [ci] Terminate (and restart) test worker when test fails (#6562) (by **Proton**)
   - [aot] Switch aot tests to use a script in taichi-aot-demo (#6559) (by **Ailing**)
   - [ci] Skip match_any and match_all intrinsics for Pascal (#6555) (by **Haidong Lan**)
   - [lang] MatrixType bug fix: Make test_mpm88 work properly (#6557) (by **Yi Xu**)
   - [Lang] MatrixType refactor: Support matrix factories (#6560) (by **Yi Xu**)
   - [lang] MatrixType bug fix: Fix type error with struct-for loop index (#6531) (by **Zhanlue Yang**)
   - [ci] Marker for running resource intensive tests in serial (#6565) (by **Proton**)
   - [ci] GitHub Actions: Merge CPU & GPU tasks (#6476) (by **Proton**)
   - [bug] Rehash compile config map in advance (#6550) (by **Lin Jiang**)
   - [aot] Deprecate filename arg in ti.aot.Module.save() (#6554) (by **Ailing**)
   - [lang] Add matrix support for Dynamic SNode (#6535) (by **Lin Jiang**)
   - [aot] Enable aot tutorial demo in CI (#6543) (by **Ailing**)
   - [refactor] Remove redundant checks when demoting dense struct fors (#6484) (by **Yi Xu**)
   - [lang] MatrixType bug fix: Fix matrix indexing error with SharedArray (#6534) (by **Zhanlue Yang**)
   - [bug] [aot] Fix texture struct for with cgraph (#6536) (by **Ailing**)
   - [Lang] MatrixType refactor: Support dot/cross/outer_product (#6545) (by **Yi Xu**)
   - [Lang] Add deactivate attribute to dynamic snodes (#6512) (by **Zhao Liang**)
   - [lang] MatrixType bug fix: Allow builtin any() and all() (#6533) (by **Yi Xu**)
   - [lang] MatrixType bug fix: Fix error message mismatch (#6532) (by **Zhanlue Yang**)
   - [opt] Eliminate redundant BitExtractStmt for SNode access under non-packed mode (#6530) (by **Yi Xu**)
   - [build] Fix error with AOT file generation & reset Android test folder per run (#6496) (by **Zhanlue Yang**)
   - [Lang] Matrix lib: Stop changing dimension in transpose() (#6528) (by **Yi Xu**)
   - [misc] Add dynamic_index to offline cache key (#6524) (by **PGZXB**)
   - [ci] GitHub Action slack bot message, again :( (#6529) (by **Proton**)
   - [Lang] Add element access for sparse matrix on CUDA (#6250) (by **Jiafeng Liu**)
   - [ci] Raise CPU tasks timeout (temporary workaround) (#6527) (by **Proton**)
   - [ci] Update slack message to include workflow_url instead of head commit (#6526) (by **Ailing**)
   - [test] Test real function on enabling the offline cache (#6523) (by **PGZXB**)
   - [lang] MatrixType refactor: Simplify reduction ops (#6521) (by **Yi Xu**)
   - [lang] Add support for real matrix args on real function (#6522) (by **Lin Jiang**)
   - [bug] Fix that the cgraph doesn't respect the caps set by ti.aot.Module() (#6520) (by **PGZXB**)
   - [aot] Fixed vulkan texture usage export (#6519) (by **PENGUINLIONG**)
   - Revert "[Misc] Improve gif output compression rate" (#6517) (by **Ailing**)
   - [lang] MatrixType refactor: Properly raise error when dynamic_index=False (#6499) (by **Yi Xu**)
   - [Lang] MatrixType refactor part 2: add more ops (#6425) (by **Mike He**)
   - [Misc] Improve gif output compression rate (#6289) (by **Zhao Liang**)
   - [lang] Add support for struct on Dynamic SNode (#6502) (by **Lin Jiang**)
   - [ci] Fix master notification bot json format (#6511) (by **Proton**)
   - [cuda] Enable test on dense dynamic field (#6510) (by **Lin Jiang**)
   - [lang] MatrixType refactor: Support vector swizzle (#6506) (by **Yi Xu**)
   - [aot] Select any of vkGetPhysicalDeviceMemoryProperties2 (#6498) (by **PENGUINLIONG**)
   - [ci] Fix master bot text format (#6507) (by **Proton**)
   - [refactor] Simplify logic in get_function_body. (#6503) (by **Ailing**)
   - [lang] Support matrix args on real function (#6493) (by **Lin Jiang**)
   - [ci] Add taichi bot to send message to slack on master failure (#6501) (by **Ailing**)
   - [aot] Move arch in Runtime wrapper object (#6504) (by **PENGUINLIONG**)
   - [example] Fix out-of-bound access in examples (#6500) (by **Yi Xu**)
   - [refactor] Remove unused has_external_arrays flag (#6497) (by **Ailing**)
   - [aot] Disable physical storage buffer in runtime (#6494) (by **PENGUINLIONG**)
   - [ci] Package C-API in nightly builds (#6479) (by **Proton**)
   - [llvm] Add support for data types of different sizes on dynamic SNode (#6490) (by **Lin Jiang**)
   - [llvm] Set the name of the LLVM function of the real function to its name (#6495) (by **Lin Jiang**)
   - [opt] Revert "Eliminate redundant BitExtractStmt for SNode access under non-packed mode (#6491) (by **Proton**)
   - [aot] Add JSON serde (#6470) (by **PENGUINLIONG**)
   - [opt] Eliminate redundant BitExtractStmt for SNode access under non-packed mode (#6485) (by **Yi Xu**)
   - [lang] MatrixType bug fix: Demote ret_type for ArgLoadStmt after scalarization (#6433) (by **Zhanlue Yang**)
   - [test] MatrixType refactor: Add tests for writing to matrix slice (#6480) (by **Yi Xu**)
   - [Error] Shorten traceback for _BoundedDifferentiableMethod (#6475) (by **Lin Jiang**)
   - [Error] Return NotImplemented for operations between field and Expr/Matrix/Struct (#6474) (by **Lin Jiang**)
   - [Error] Return TaichiTypeError in ASTTransformer when a binary op is not supported (#6477) (by **Lin Jiang**)
   - [ci] Switch linux gpu job to use LLVM 15 (#6465) (by **Ailing**)
   - [aot] Modify aot-demo.sh to track master branch of taichi-aot-demo (#6473) (by **Zhanlue Yang**)
   - [ci] Move implicit fem android demo to master branch (#6463) (by **Ailing**)
   - [aot] Add VkDeviceMemory to TiVulkanMemoryInteropInfo (#6442) (by **Zhanlue Yang**)
   - [aot] Disabled physical storage buffer temporarily (#6468) (by **PENGUINLIONG**)
   - [ci] Add PR tag for amdgpu. (#6466) (by **Zeyu Li**)
   - [Bug] [error] Add argument 'module' to 'warn_explicit' to show the deprecated warning (#6467) (by **Lin Jiang**)
   - [bug] Fix false overflow alarm in struct fors under packed mode (#6457) (by **Yi Xu**)
   - [Bug] Fix cache_loop_invariant_global_vars pass (#6462) (by **Lin Jiang**)
   - [llvm] Fix broken llvm module on CUDA backend when TI_LLVM_15 is on (#6458) (by **Ailing**)
   - Revert "[ci] Add unix end-to-end CI tests for meshtaichi" (#6460) (by **Ailing**)
   - [lang] MatrixType bug fix: support star & loop operations over matrix-typed Expr (#6427) (by **Zhanlue Yang**)
   - [ci] Add unix end-to-end CI tests for meshtaichi (#6453) (by **yixu**)
   - [CUDA] Add maximum stack limit to CompileConfig (#6455) (by **Lin Jiang**)
   - [ci] Swtich CPU jobs to use prebuilt LLVM15 (#6435) (by **Ailing**)
   - [Bug] Fix memory leak in SPIRV module (#6449) (by **yekuang**)
   - [llvm] Allocate RuntimeContext on heap (#6420) (by **Lin Jiang**)
   - [opt] Eliminate redundant mod for SNode access under packed mode (#6444) (by **Yi Xu**)
   - [vulkan] Disable NoSignedWrap decoration on vulkan backend (#6440) (by **Ailing**)
   - [example] Ti-example: phase field simulation of snow growth (#6439) (by **莫翰轩**)
   - [misc] Bump version to v1.2.1 (#6436) (by **Zhanlue Yang**)
   - [Lang] MatrixType refactor: Support matrix slice (#6430) (by **Yi Xu**)
   - [aot] Warns the user when mapping device-only memory (#6417) (by **PENGUINLIONG**)
   - [Error] Deprecate ndrange with number of the loop variables != the dimension of the ndrange (#6422) (by **Lin Jiang**)
   - [aot] Support push_arg for Kernel in C++ wrapper (#6419) (by **Ailing**)
   - [aot] Use count instead of size-in-bytes for ND-array access in C++ wrapper (#6409) (by **PENGUINLIONG**)
   - [aot] Rename incomplete to truncated (#6418) (by **PENGUINLIONG**)
   - [error] Warn Linux users about manylinux2014 build on startup (#6416) (by **Proton**)
   - [vulkan] [bug] Stop using the buffer device address feature on macOS (#6415) (by **Yi Xu**)
   - [aot] Fixed default list (#6403) (by **PENGUINLIONG**)
   - [aot] Device capability refactorization (#6184) (by **PENGUINLIONG**)
   - [bug] Fix flaky test with taichi_sparse_test.cpp (#6400) (by **Zhanlue Yang**)
   - [Lang] Allow augmented assign on matric slice (#6382) (by **Yi Xu**)
   - [Doc] Update global_settings.md (#6370) (by **Zhao Liang**)
   - [example] Change unnecessary ti.ndrange call to range in Karmal vortex example (#6389) (by **Zhao Liang**)
   - [Lang] [bug] Allow filling a field with Expr (#6391) (by **Yi Xu**)
   - [bug] [lang] Fix copyback for fortran contiguous numpy arrays" (#6390) (by **Ailing Zhang**)
   - [lang] Fix from_numpy() for vector field with a non-contiguous array (by **Ailing Zhang**)
   - [Doc] Update global data access rule checker in doc (#6347) (by **Mingrui Zhang**)
   - [lang] Texture format for better expressiveness (#6338) (by **PENGUINLIONG**)
   - [spirv] Fix duplicated interface id for global_tmp buffers (#6392) (by **Ailing**)
   - Revert "[bug] [lang] Fix copyback for fortran contiguous numpy arrays" (#6390) (by **Ailing**)
   - [bug] [lang] Fix copyback for fortran contiguous numpy arrays (#6376) (by **Ailing**)
   - [Lang] Replace matrix warning param by current logging level (#6377) (by **Zhao Liang**)
   - [misc] Tweak CMake clang exec messages (#6379) (by **yekuang**)
   - [lang] Support structured for loop for RW texture (#6336) (by **PENGUINLIONG**)
   - [autodiff] Fix mode capture for validation kernels (#6361) (by **Mingrui Zhang**)
   - [lang] MatrixType bug fix: Support returning an Expr with MatrixType (#6375) (by **Yi Xu**)
   - [lang] MatrixType bug fix: Fix error with print of MatrixType (#6340) (by **Zhanlue Yang**)
   - [autodiff] Add complicated test case for gdar checker (#6366) (by **Mingrui Zhang**)
   - [lang] [refactor] Refine implementation and tests for matrix slice (#6373) (by **Yi Xu**)
   - [lang] MatrixType bug fix: Add support for unpacking Expr with MatrixType (#6341) (by **Zhanlue Yang**)
   - [Lang] Matrix/Vector refactor: Matrix operations part 1 (#6319) (by **Mike He**)
   - [bug] Fix potential bug in #6362 (#6363) (by **Yi Xu**)
   - [mesh] Fix MeshTaichi warnings in CUDA backend (#6369) (by **Chang Yu**)
   - [bug] Fix returning uint64 as signed integer (#6364) (by **Lin Jiang**)
   - [doc] Update doc about how to use vulkan print (#6359) (by **Ailing**)
   - [Error] Add error message when the number of the loop variables does not match the dimension of the ndrange (#6360) (by **Lin Jiang**)
